package uniklu.games.spaceship;

import javazoom.spi.vorbis.sampled.file.VorbisAudioFileReader;

import javax.sound.sampled.*;
import java.applet.AudioClip;
import java.applet.Applet;
import java.io.IOException;

public class AdvancedSoundLib extends SoundLib {
    Clip  shot, xplode;
    Clip bgMusic;

    public AdvancedSoundLib() {
        initMusic();
    }

    private void initMusic() {
//       bgMusic = Applet.newAudioClip(getClass().getResource("sfx/blastar2.mid"));
//        xplode = Applet.newAudioClip(getClass().getResource("sfx/laser_canon.wav"));
//        shot = Applet.newAudioClip(getClass().getResource("sfx/phase_array.wav"));
        try {
            shot = AudioSystem.getClip();
            shot.open(AudioSystem.getAudioInputStream(getClass().getResource("sfx/phase_array.wav")));
            xplode = AudioSystem.getClip();
            xplode.open(AudioSystem.getAudioInputStream(getClass().getResource("sfx/laser_canon.wav")));

            bgMusic = AudioSystem.getClip();
            AudioInputStream in = AudioSystem.getAudioInputStream(getClass().getResource("sfx/rool-oh_why.mp3"));
            AudioFormat inFormat = in.getFormat();
            AudioFormat decodedFormat = new AudioFormat(AudioFormat.Encoding.PCM_SIGNED,
                    inFormat.getSampleRate(), 16, inFormat.getChannels(),
                    inFormat.getChannels() * 2, inFormat.getSampleRate(), false
            );
            bgMusic.open(AudioSystem.getAudioInputStream(decodedFormat, in));
        } catch (UnsupportedAudioFileException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        } catch (IOException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        } catch (LineUnavailableException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
    }

    public void startBackgroundMusic() {
        if (!bgMusic.isActive())
            bgMusic.loop(Clip.LOOP_CONTINUOUSLY);
    }

    public void sfxShot() {
        if (!shot.isActive()) {
            shot.setFramePosition(1);
            shot.start();
        }
    }

    public void sfxXplode() {
        if (shot.isActive()) {
            shot.stop();
            xplode.stop();
        }
        if (!xplode.isActive()) {
            xplode.setFramePosition(1);
            xplode.start();
        }    }
}