package uniklu.games.spaceship;

import javax.sound.sampled.*;
import java.io.IOException;

/**
 * Created by IntelliJ IDEA.
 * User: install
 * Date: 17.04.2008
 * Time: 21:34:20
 * To change this template use File | Settings | File Templates.
 */
public class SoundThread implements Runnable {
    AudioFormat targetFormat;
    AudioInputStream din;

    public SoundThread(AudioFormat targetFormat, AudioInputStream din) {
        this.targetFormat = targetFormat;
        this.din = din;
    }

    /**
     * Plays it once and then stops ...
     * @throws LineUnavailableException
     * @throws IOException
     */
    private void play() throws LineUnavailableException, IOException {
        byte[] data = new byte[4096];
        SourceDataLine line = getLine(targetFormat);
        if (line != null) {
            // Start
            line.start();
            int nBytesRead = 0, nBytesWritten = 0;
            while (nBytesRead != -1) {
                nBytesRead = din.read(data, 0, data.length);
                if (nBytesRead != -1) nBytesWritten = line.write(data, 0, nBytesRead);
            }
            // Stop
            line.drain();
            line.stop();
            line.close();
            din.close();
        }
    }

    private SourceDataLine getLine(AudioFormat audioFormat) throws LineUnavailableException {
        SourceDataLine res = null;
        DataLine.Info info = new DataLine.Info(SourceDataLine.class, audioFormat);
        res = (SourceDataLine) AudioSystem.getLine(info);
        res.open(audioFormat);
        return res;
    }

    public void run() {
        try {
            play();
        } catch (LineUnavailableException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        } catch (IOException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
    }
}
